unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure FormPaint(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// procedura rysuje prostokąt koloru czerwonego i przypisuje procedurze obsługi zdarzenia OnPaint procedurę MojaProc
procedure TForm1.Button1Click(Sender: TObject);
begin
  Canvas.Pen.Color:=clRed;
  Canvas.Rectangle(100,100,ClientWidth-100,ClientHeight-100);
 OnPaint:=FormPaint;//przypisanie procedurze obsługi zdarzenia procedury rysującej  ĺprost.
end;

// odłączenie procedury MojaProc od zdarzenia OnPaint — wykasowanie prostokąta
procedure TForm1.Button2Click(Sender: TObject);
begin
  OnPaint:=nil;  //ta instrukcja spowoduje, że rysunek prostokąta nie będzie odnawiany
  Refresh;      //procedura ta kasuje prostokąt
end;


procedure TForm1.FormPaint(Sender: TObject);
begin
   Canvas.Rectangle(100,100,ClientWidth-100,ClientHeight-100);
end;

end.
